<?php

function commerce_cashbill_verify()
{
    
    $payment_method = commerce_payment_method_instance_load('cashbill|commerce_payment_cashbill');


if(md5($_GET['cmd'].$_GET['args'].$payment_method['settings']['userkey']) == $_GET['sign'])
{

    if($payment_method['settings']['mode'] == 'test')
    {
        $paymentUrl = 'https://pay.cashbill.pl/testws/rest/';
    }else
    {    
        $paymentUrl = 'https://pay.cashbill.pl/ws/rest/';
    }

  $response = _commerce_cashbill_get_request($paymentUrl.'payment/'.$payment_method['settings']['userid'].'/'.$_GET['args'].'?sign='.SHA1($_GET['args'].$payment_method['settings']['userkey']));


$order_id = $response->additionalData;
$order = commerce_order_load($order_id);

$transaction = commerce_payment_transaction_new('cashbill', $order_id);
$transaction->created = time();

$transaction->instance_id = $payment_method['instance_id'];

$transaction->remote_id = $_GET['args'];
$transaction->amount = $response->amount->value*100;
$transaction->currency_code = $response->amount->currencyCode;
$transaction->payload[REQUEST_TIME] = time();
$transaction->changed = time();



if(strtoupper($response->status) == 'ABORT' || strtoupper($response->status) == 'FRAUD' || $response->status == 'NegativeAuthorization' )
{
$transaction->message = 'Transakcja nie powiodła się';
$transaction->status = COMMERCE_PAYMENT_STATUS_FAILURE;
$transaction->remote_status = $transaction->status;
commerce_payment_transaction_save($transaction);
}

if( strtoupper($response->status) == 'POSITIVEFINISH' )
{
$transaction->message = 'Płatność w kwocie '.$response->amount->value.' '.$response->amount->currencyCode.' została przyjęta przez CashBill';
$transaction->status = COMMERCE_PAYMENT_STATUS_SUCCESS;
$order->status = 'completed';
$transaction->remote_status = $transaction->status;
commerce_payment_transaction_save($transaction);
}

echo 'OK';

exit();
}
echo 'BLAD SYGNATURY';    
}

function _commerce_cashbill_get_request($url) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $server_output = curl_exec($ch);
    curl_close($ch);
    return json_decode($server_output);
}